% CoMa2 - SS11
% Aufg.3.3 2.
function [p,anzpkt] = aitkenneville(x,f,z)
% Programm wertet das Interpolationspolynom an gewissen Stellen aus, ohne
% vorher das Polynom aufzustellen

% Inputs: Vektor x=(x_1,...,x_n) mit Sttzstellen, Vektor f mit
% Funktionswerten f(x_1),...,f_(x_n) und Stelle z, an der das 
% Interpolationspolynom ausgewertet werden soll
% Outputs: Vektor p mit Werten des Interpolationspolynoms an den Stellen z
% anzpkt ist die Anzahl der bentigten Punktoperationen

% Algorithmus 1.7, Aitken-Neville-Schema

anzpkt = 0;
p = zeros(1,length(z));
n = length(x);  % x und f sollten gleich lange Vektoren sein
for j=1:length(z)
    % Baue Schema mit Hilfe einer Matrix auf
    A = zeros(n,n);
    A(:,1) = f;     % p_ii(z)  i=1,...,n
    for i = 2:n
        for k = i:n
            A(k,i) = (1/(x(k) - x(k-i+1))) * ( (z(j)-x(k-i+1)) * A(k,i-1) - (z(j)-x(k)) * A(k-1,i-1));
            % p_ik  i<k
            anzpkt = anzpkt + 3;    % 2 Multiplikationen und 1 Division
        end
    end
    % Ergebnis:
    p(j) = A(n,n);
end