% CoMa2 - SS11
% Zu Aufg.3.3 1.(a)
function [p,anzpkt] = horner(x,a,z)
% Programm wertet Newtonsches Interpolationspolynom an den Stellen z aus
% und gibt Werte zurck
% Inputs: Vektor x=(x_1,...,x_n) mit Sttzstellen und Vektor
% a=(a_1,...,a_n) mit Koeffizienten des Newtonschen Interpolationspolynoms,
% Vektor z mit Stellen, an denen das Interpolationspolynom ausgewertet
% werden soll
% Outputs: Vektor p mit Werten des Interpolationspolynoms an den Stellen z
% anzpkt ist die Anzahl der bentigten Punktoperationen
% Vorgehen nach Algorithmus 1.3, Horner-Schema

anzpkt = 0;
n = length(a);  % Voraussetzung: x und a gleich lange Vektoren
% Initialisierung
S(n,:) = a(n)*ones(1,length(z));
% Rekursion
for k=n-1:-1:1
    S(k,:) = S(k+1,:) .* (z-x(k)) + a(k);
    anzpkt = anzpkt + 1*length(z);  % pro Schleifendurchlauf length(z)*1 
    % viele Multiplikationen
end
% Ergebnis:
p = S(1,:);